﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
//
using FTD2XX_NET;

namespace PCL6115_EV2S
{
    public partial class Form1 : Form
    {

        ////////////////////////////////////////////////////////////////////
        /// <summary>
        /// クラス／テーブル
        /// Class / Table
        /// </summary>
        //private clsFTDI hFTDI = new clsFTDI();
        private accessPCL6115 hPCL6115 = new accessPCL6115();
        private samplePCL6115EV2S hSample = new samplePCL6115EV2S();

        ////////////////////////////////////////////////////////////////////
        //
        public Form1()
        {
            InitializeComponent();
        }

        ////////////////////////////////////////////////////////////////////
        /// <summary>
        /// Form作成
        /// Form Creation
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void Form1_Load(object sender, EventArgs e)
        {
            if(hPCL6115.Open() == -1)
            {
                //オープン失敗
                //Open Failure
                MessageBox.Show("PCL6115-EV not found.", "Error !!!");
                hPCL6115.PCL6115EV_stop = true;//falseだと終了できない //Can not end with false
                Close();
            }

            hPCL6115.InitPCL6115STK();
            hPCL6115.PCL6115EV_stop = true;//中断フラグ＝オン // Interrupt flag = on

            //画面中央に配置
            //Placed in the center of the screen
            this.Left = (System.Windows.Forms.Screen.PrimaryScreen.Bounds.Width - this.Width) / 2;
            this.Top = (System.Windows.Forms.Screen.PrimaryScreen.Bounds.Height - this.Height) / 2;
        }

        ////////////////////////////////////////////////////////////////////
        /// <summary>
        /// Form破棄
        /// Discard Form
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (hPCL6115.PCL6115EV_stop == false)
            {
                e.Cancel = true;
            }
            else
            {
                hPCL6115.Close();
            }
        }

        ////////////////////////////////////////////////////////////////////
        /// <summary>
        /// サンプルの実行
        /// Execution Sample
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void SampleExe_Click(object sender, EventArgs e)
        {
            hPCL6115.PCL6115EV_stop = false;//中断フラグ＝オフ // Interrupt flag = off
            this.Focus();
            //メイン側に処理が移行すると、Form1側のボタンが1回無視される。これを防ぐためフォーカスを保持させる。
            //When processing shifts to the main side, the button on Form 1 side is ignored once. In order to prevent this, keep focus.
            if (hSample.main(hPCL6115) == 0)
            {
                MessageBox.Show("Sample operation end.", "message");
            }
            else
            {
                MessageBox.Show("Sample operation interrupted.", "message");
            }
        }

        ////////////////////////////////////////////////////////////////////
        /// <summary>
        /// サンプルの停止
        /// Stop Sample
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void bt_stop_Click(object sender, EventArgs e)
        {
            hPCL6115.PCL6115EV_stop = true;//中断フラグ＝オン // Interrupt flag = on
        }

        ////////////////////////////////////////////////////////////////////
        /// <summary>
        /// ソフトウェアの終了
        /// End of software
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void bt_exit_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
